__author__ = 'tomaton'

import json
import matplotlib.pyplot as plt
from pyfmi import load_fmu
import sys

import numpy as N

#load data into "data" structure
json_data = open('sample.dat')

data = json.load(json_data)
json_data.close()

#run simulation

#Load the FMU
model = load_fmu('DvaBalony2_DvaBalonyFlat.fmu')

#Simulate an FMU
opts = model.simulate_options()
opts["ncp"] = 100 #One hundred output points
#res = model.simulate(final_time=10,options=opts)
vres=0.0
vmin=sys.float_info.max;
#v2res=0.0
#compare res and data
#v1res = (res['V1']-data['V1'])**2
#v2res = (res['V2']-data['V2'])**2
#v1sum = sum(v1res)
#v2sum = sum(v2res)

#Simulate multiple times FMU and change parameters of it and compute norm from sample data
def drange(start,stop,step):
    r = start
    while r<stop:
        yield r
        r+=step

for elastance in drange (0.1,3,0.1):
    for resistance in drange(0.1, 6, 0.1):
        model.reset()
        model.set('R',resistance)
        model.set('E1',elastance)
        res = model.simulate(final_time=10,options=opts)
        vres = sum((res['V1']-data['V1'])**2)+ sum((res['V2']-data['V2'])**2)
        if vmin:
            if  vmin>vres:
                vmin=vres
                minres=res
                minR=resistance
                minE=elastance

print minR,minE,vmin

plt.figure()
plt.plot(minres['time'],minres['V1'])
plt.plot(minres['time'],data['V1'])
plt.plot(minres['time'],minres['V2'])
plt.plot(minres['time'],data['V2'])
plt.show()
